Scriptname mf_SpectatorCrowdsConfig extends SKI_ConfigBase  

bool Property MoralityGuardActive = false Auto
bool Property SpectatorCrowdActive = true Auto
bool Property CitySexUnlawful = false Auto
bool Property CitySexProhibited = false Auto
bool Property CreatureSexProhibited = false Auto
bool Property AggressiveSexUnlawful = false Auto
bool Property GuardsAttackAggressors = false Auto
bool Property DebugMode = false Auto
bool Property SpectatorNotifications = true Auto

bool Property GaySpectatorsDislikeLesbianSex = true Auto
bool Property LesbianSpectatorsDislikeGaySex = true Auto
bool Property StraightMaleSpectatorsDislikeGaySex = false Auto
bool Property StraightFemaleSpectatorsDislikeLesbianSex = false Auto

bool Property EnableCitySexPurityOverride = true Auto
float Property CitySexPurityOverrideThreshold = -1.0 Auto
Bool Property EnableCitySexArousalOverride = true Auto
float Property CitySexArousalOverrideThreshold = 80.0 Auto
bool Property EnableCreatureSexPurityOverride = true Auto
float Property CreatureSexPurityOverrideThreshold = -1.0 Auto
Bool Property EnableCreatureSexArousalOverride = true Auto
float Property CreatureSexArousalOverrideThreshold = 80.0 Auto

int Property MaxParticipant = 128 Auto

float Property ScanInterval = 1.0 Auto
int Property ParticipantPerScan = 128 Auto
float Property MeterPerUnit = 0.01428 Auto
GlobalVariable Property AggroDistance Auto
GlobalVariable Property MaxSpectatorDistance Auto

;-------------------------
int idMGA
int idSCA
int idSSI
int idPPS
int idMP
int idAD
int idCSU
int idCiSP
int idCrSP
int idASU
int idGAA
int idDBG
int idMSD
int idSPN

int idGSDLS
int idLSDGS
int idSMDGS
int idSFDLS
int idPCiSP
int idPCiSPT
int idACiSP
int idACiSPT
int idPCrSP
int idPCrSPT
int idACrSP
int idACrSPT


int function GetVersion()
	return 2 
endFunction


event OnConfigInit()
	ModName = "Spectator Crowds"

	Pages = new string[2]
	Pages[0] = "General"
	Pages[1] = "Spectator AI"
endEvent


event OnVersionUpdate(int newVersion)

endEvent


event OnPageReset(string pagename)

	if(pagename == "General")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Toggles")
		idMGA = AddToggleOption("Morality Guard", MoralityGuardActive)
		idSCA = AddToggleOption("Spectators", SpectatorCrowdActive)
		idDBG = AddToggleOption("Debug Mode", DebugMode)
		AddHeaderOption("Detection")
		idAD  = AddSliderOption("Aggro Distance", AggroDistance.GetValue() * MeterPerUnit, "{0} meters")
		idMSD  = AddSliderOption("Max Spectator Distance", MaxSpectatorDistance.GetValue() * MeterPerUnit, "{0} meters")
		idSSI = AddSliderOption("Scan Interval", ScanInterval, "{0} sec")
		idPPS = AddSliderOption("Participant Per Scan", ParticipantPerScan as float, "{0}")
		SetCursorPosition(1)
		AddHeaderOption("Morality Guards Settings")
		idCSU = AddToggleOption("Sex in Cities is Unlawful", CitySexUnlawful)
		idASU = AddToggleOption("Aggressive Sex is Unlawful", AggressiveSexUnlawful)
		idGAA = AddToggleOption("Guards will Attack Aggressors", GuardsAttackAggressors)		
		AddHeaderOption("Spectators Settings")
		idSPN = AddToggleOption("Spectator Notifications", SpectatorNotifications)
		idMP  = AddSliderOption("Max number of spectators", MaxParticipant, "{0}")
	elseif(pagename == "Spectator AI")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Gay Spectators...")
		idGSDLS = AddToggleOption("... Dislike Lesbian Sex", GaySpectatorsDislikeLesbianSex)
		AddHeaderOption("Lesbian Spectators...")
		idLSDGS = AddToggleOption("... Dislike Gay Sex", LesbianSpectatorsDislikeGaySex)
		AddHeaderOption("Straight Male Spectators...")
		idSMDGS = AddToggleOption("... Dislike Gay Sex", StraightMaleSpectatorsDislikeGaySex)
		AddHeaderOption("Straight Female Spectators...")
		idSFDLS = AddToggleOption("... Dislike Lesbian Sex", StraightFemaleSpectatorsDislikeLesbianSex)
		SetCursorPosition(1)
		AddHeaderOption("Sex in Cities")
		idCiSP = AddToggleOption("City Sex is Prohibited", CitySexProhibited)
		idPCiSP = AddToggleOption("Purity Override", EnableCitySexPurityOverride) 
		idPCiSPT = AddSliderOption("Purity Threshold", CitySexPurityOverrideThreshold, "{0}")
		idACiSP = AddToggleOption("Arousal Override", EnableCitySexArousalOverride) 
		idACiSPT = AddSliderOption("Arousal Threshold", CitySexArousalOverrideThreshold, "{0}")
		AddHeaderOption("Sex with Creatures")
		idCrSP  = AddToggleOption("Creature Sex Prohibited", CreatureSexProhibited)
		idPCrSP = AddToggleOption("Purity Override", EnableCreatureSexPurityOverride) 
		idPCrSPT = AddSliderOption("Purity Threshold", CreatureSexPurityOverrideThreshold, "{0}")
		idACrSP = AddToggleOption("Arousal Override", EnableCreatureSexArousalOverride) 
		idACrSPT = AddSliderOption("Arousal Threshold", CreatureSexArousalOverrideThreshold, "{0}")	
	endif
endEvent


event OnOptionSelect(int option)
	if (option == idMGA)  ;  toggle morality guard
		MoralityGuardActive = !MoralityGuardActive
		SetToggleOptionValue(idMGA, MoralityGuardActive)
	elseif (option == idGSDLS) ; toggle Gay Spectators Dislike Lesbian Sex
		GaySpectatorsDislikeLesbianSex = !GaySpectatorsDislikeLesbianSex
		SetToggleOptionValue(idGSDLS, GaySpectatorsDislikeLesbianSex)
	elseif (option == idLSDGS) ; toggle Lesbian Spectators Dislike Gay Sex
		LesbianSpectatorsDislikeGaySex = !LesbianSpectatorsDislikeGaySex
		SetToggleOptionValue(idLSDGS, LesbianSpectatorsDislikeGaySex)
	elseif (option == idSMDGS) ; toggle Straight male spectators dislike gay sex
		StraightMaleSpectatorsDislikeGaySex = !StraightMaleSpectatorsDislikeGaySex
		SetToggleOptionValue(idSMDGS, StraightMaleSpectatorsDislikeGaySex)
	elseif (option == idSFDLS) ; toggle Straight female spectators dislike gay sex
		StraightFemaleSpectatorsDislikeLesbianSex = !StraightFemaleSpectatorsDislikeLesbianSex
		SetToggleOptionValue(idSFDLS, StraightFemaleSpectatorsDislikeLesbianSex)
	elseif (option == idSCA)	; toggle spectator crowd
		SpectatorCrowdActive = !SpectatorCrowdActive
		SetToggleOptionValue(idSCA, SpectatorCrowdActive)
	elseif (option == idCiSP)	; toggle city sex prohibited
		CitySexProhibited = !CitySexProhibited
		SetToggleOptionValue(idCiSP, CitySexProhibited)
	elseif (option == idCrSP)	; toggle creature sex prohibited
		CreatureSexProhibited = !CreatureSexProhibited
		SetToggleOptionValue(idCrSP, CreatureSexProhibited)
	elseif (option == idCSU)	; toggle city sex unlawful
		CitySexUnlawful = !CitySexUnlawful
		SetToggleOptionValue(idCSU, CitySexUnlawful)
	elseif (option == idASU)	; toggle aggressive sex unlawful
		AggressiveSexUnlawful = !AggressiveSexUnlawful
		SetToggleOptionValue(idASU, AggressiveSexUnlawful)
	elseif (option == idGAA)	; toggle guards attack aggressors
		GuardsAttackAggressors = !GuardsAttackAggressors
		SetToggleOptionValue(idGAA, GuardsAttackAggressors)
	elseif (option == idDBG)	; toggle debug mode
		DebugMode = !DebugMode
		SetToggleOptionValue(idDBG, DebugMode)
	elseif (option == idSPN)	; toggle spectator notification messages
		SpectatorNotifications = !SpectatorNotifications
		SetToggleOptionValue(idSPN, SpectatorNotifications)
	elseif (option == idPCiSP)	; toggle city sex purity override
		EnableCitySexPurityOverride = !EnableCitySexPurityOverride
		SetToggleOptionValue(idPCiSP, EnableCitySexPurityOverride)
	elseif (option == idACiSP)	; toggle city sex arousal override
		EnableCitySexArousalOverride = !EnableCitySexArousalOverride
		SetToggleOptionValue(idACiSP, EnableCitySexArousalOverride)
	elseif (option == idPCrSP)	; toggle Creature sex purity override
		EnableCreatureSexPurityOverride = !EnableCreatureSexPurityOverride
		SetToggleOptionValue(idPCrSP, EnableCreatureSexPurityOverride)
	elseif (option == idACrSP)	; toggle Creature sex arousal override
		EnableCreatureSexArousalOverride = !EnableCreatureSexArousalOverride
		SetToggleOptionValue(idACrSP, EnableCreatureSexArousalOverride)
	endif
endEvent


event OnOptionHighlight(int option)
	if (option == idMGA) ;  toggle morality guard
		SetInfoText("Guards won't stop scene if this feature is off")
	elseif (option == idSCA) ; toggle spectator crowd
		SetInfoText("NPC won't gather around you if this feature is off")
	elseif(option == idAD) 
		SetInfoText("Below this distance, NPC don't need LOS - otherwise LOS only")
	elseif(option == idSSI)
		SetInfoText("Scan interval during sex")
	elseif(option == idCSU)
		SetInfoText("Sets whether having sex in cities breaks the law")
	elseif(option == idCiSP)
		SetInfoText("Sets whether having sex in cities is prohibited.\nAffects the per-spectator Like/Dislike calculation for the sex act, as well as dialogue.")
	elseif(option == idCrSP)
		SetInfoText("Sets whether having sex involving creatures is prohibited.\nAffects the per-spectator Like/Dislike calculation for the sex act, as well as dialogue.")
	elseif(option == idASU)
		SetInfoText("Sets whether having aggressive sex anywhere breaks the law")
	elseif(option == idGAA)
		SetInfoText("Sets whether guards will attack the aggressor in aggressive sex.")
	elseif(option == idDBG)
		SetInfoText("Adds additional debugging messages.")
	elseif(option == idSPN)
		SetInfoText("Enables/disables notifications that spectators have gone to watch the sex act or other status updates.")
	elseif(option == idMSD)
		SetInfoText("Sets the maximum distance from the player that an NPC must be in order to be considered as a spectator for a sex act.")
	elseif(option == idGSDLS)
		SetInfoText("If enabled, gay spectators will dislike lesbian sex.")
	elseif(option == idLSDGS)
		SetInfoText("If enabled, lesbian spectators will dislike gay sex.")
	elseif(option == idSMDGS)
		SetInfoText("If enabled, straight male spectators will dislike gay sex.")
	elseif(option == idSFDLS)
		SetInfoText("If enabled, straight female spectators will dislike lesbian sex.")
	elseif(option == idPCiSP)
		SetInfoText("If enabled, prohibited city sex may be liked by some spectators as long as their purity is low enough.")
	elseif(option == idPCiSPT)
		SetInfoText("Purity Threshold (lower is more impure). If spectator's purity is LOWER than this value, it will be liked even though it is prohibited.")
	elseif(option == idACiSP)
		SetInfoText("If enabled, prohibited city sex may be liked by some spectators as long as their arousal is high enough.")
	elseif(option == idACiSPT)
		SetInfoText("Arousal Threshold (higher is more aroused). If spectator's purity is HIGHER than this value, it will be liked even though it is prohibited.")
	elseif(option == idPCrSP)
		SetInfoText("If enabled, prohibited creature sex may be liked by some spectators as long as their purity is low enough.")
	elseif(option == idPCrSPT)
		SetInfoText("Purity Threshold (lower is more impure). If spectator's purity is LOWER than this value, it will be liked even though it is prohibited.")
	elseif(option == idACrSP)
		SetInfoText("If enabled, prohibited creature sex may be liked by some spectators as long as their arousal is high enough.")
	elseif(option == idACrSPT)
		SetInfoText("Purity Threshold (lower is more impure). If spectator's purity is LOWER than this value, it will be liked even though it is prohibited.")
	endif
endEvent



event OnOptionSliderOpen(int option)
	if (option == idAD)
		SetSliderDialogStartValue(AggroDistance.GetValue() * MeterPerUnit)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(10.0)
	elseif (option == idMSD)
		SetSliderDialogStartValue(MaxSpectatorDistance.GetValue() * MeterPerUnit)
		SetSliderDialogDefaultValue(60.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(10.0)
	elseif(option == idMP)
		SetSliderDialogStartValue(MaxParticipant)
		SetSliderDialogDefaultValue(128.0)
		SetSliderDialogRange(0.0, 128.0)
		SetSliderDialogInterval(1.0)
	elseif(option == idSSI)
		SetSliderDialogStartValue(ScanInterval)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, 30.0)
		SetSliderDialogInterval(1.0)
	elseif(option == idPPS)
		SetSliderDialogStartValue(ParticipantPerScan as float)
		SetSliderDialogDefaultValue(128.0)
		SetSliderDialogRange(1.0, 128.0)
		SetSliderDialogInterval(1.0)
	elseif(option == idPCiSPT)
		SetSliderDialogStartValue(CitySexPurityOverrideThreshold)
		SetSliderDialogDefaultValue(-1.0)
		SetSliderDialogRange(-100.0, 0.0)
		SetSliderDialogInterval(1.0)
	elseif(option == idPCrSPT)
		SetSliderDialogStartValue(CreatureSexPurityOverrideThreshold)
		SetSliderDialogDefaultValue(-1.0)
		SetSliderDialogRange(-100.0, 0.0)
		SetSliderDialogInterval(1.0)
	elseif(option == idACiSPT)
		SetSliderDialogStartValue(CitySexArousalOverrideThreshold)
		SetSliderDialogDefaultValue(60.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif(option == idACrSPT)
		SetSliderDialogStartValue(CreatureSexArousalOverrideThreshold)
		SetSliderDialogDefaultValue(60.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	endif
endEvent


event OnOptionSliderAccept(int option, float value)
	if (option == idAD)
		AggroDistance.SetValue(value / MeterPerUnit)
		SetSliderOptionValue(idAD, value, "{0} meters")
	elseif (option == idMSD)
		MaxSpectatorDistance.SetValue(value / MeterPerUnit)
		SetSliderOptionValue(idMSD, value, "{0} meters")
	elseif(option == idMP)
		MaxParticipant = value as int
		SetSliderOptionValue(idMP, value, "{0}")
	elseif(option == idSSI)
		ScanInterval = value
		SetSliderOptionValue(idSSI, value, "{0} sec")
	elseif(option == idPPS)
		ParticipantPerScan = value as int
		SetSliderOptionValue(idPPS, value, "{0}")
	elseif(option == idPCiSPT)
		CitySexPurityOverrideThreshold = value
		SetSliderOptionValue(idPCiSPT, value, "Purity at or below {0}")
	elseif(option == idPCrSPT)
		CreatureSexPurityOverrideThreshold = value
		SetSliderOptionValue(idPCrSPT, value, "Purity at or below {0}")
	elseif(option == idACiSPT)
		CitySexArousalOverrideThreshold = value
		SetSliderOptionValue(idACiSPT, value, "Arousal at least {0}")
	elseif(option == idACrSPT)
		CreatureSexArousalOverrideThreshold = value
		SetSliderOptionValue(idACrSPT, value, "Arousal at least {0}")
	endif
endEvent